float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (DX9)
float4x4 tP: PROJECTION;   //projection matrix as set via Renderer (DX9)
float4x4 tWVP: WORLDVIEWPROJECTION;



texture Tex <string uiname="Texture B&W";>;
float4x4 tTex <string uiname="Texture Transform B&W";>;                  //Texture Transform
sampler Samp = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //set the sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};



texture ImageTexture
<string uiname="Texture";>;
float4x4 tTex1 <string uiname="Texture Transform";>;
sampler2D ImageSampler = sampler_state
{
    Texture = <ImageTexture>;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = None;
};
///////////////////////////////////////vertexshader///////////////////////

float Displacement <
	string UIWidget = "slider";
	float UIMin = 0.0;
	float UIMax = 1.0;
	float UIStep = 0.001;
> = 0.01f;

struct VS_OUTPUT
{
    float4 Pos  : POSITION;
    float4 TexC : TEXCOORD0;
    float4 TexC1 : TEXCOORD1;
};

VS_OUTPUT VS(
    float4 Pos  : POSITION,
    float4 TexC : TEXCOORD,
    float4 TexC1 : TEXCOORD1)
{
    //inititalize all fields of output struct with 0
    VS_OUTPUT Out = (VS_OUTPUT)0;

    //transform position
    Pos = mul(Pos, tWVP);
    //transform texturecoordinates
    Out.TexC1 =mul(TexC, tTex1);
    TexC = mul(TexC, tTex);

    Out.Pos  = Pos;
    Out.TexC = TexC;

    return Out;
}

////////////////////////////////pixelshader////////////////////////////////////

float4 dispPS(float4 TexC: TEXCOORD0,float4 TexC1: TEXCOORD1) : COLOR
{   
	float2 disp = Displacement*(((float4)tex2D(Samp, TexC)));
	float4 texCol = tex2D(ImageSampler,TexC1+disp);
	return texCol;
} 
/////////////////////////////////technique//////////////////////////////////// 

technique deformTexture {
	pass TexturePass  {
		VertexShader = compile vs_2_0 VS();
	
		PixelShader  = compile ps_2_a dispPS();
	}
}

/***************************** eof ***/
